// Copyright (c) 2011, the Dart project authors.  Please see the AUTHORS file
// for details. All rights reserved. Use of this source code is governed by a
// BSD-style license that can be found in the LICENSE file.

package com.google.dart.compiler;

/**
 * Abstract interface to Dart source.
 */
public interface DartSource extends Source {

  /**
   * Gets the library with which this Dart source is associated.
   */
  LibrarySource getLibrary();

  /**
   * Gets the path of this source, relative to its library.
   */
  String getRelativePath();
}
